| TagLib 1.13 |  |

Public Member Functions | Protected Member Functions | Friends | List of all members
TagLib::ID3v2::GeneralEncapsulatedObjectFrame Class Reference

An ID3v2 general encapsulated object frame implementation. More...

`#include <generalencapsulatedobjectframe.h>`

Inheritance diagram for TagLib::ID3v2::GeneralEncapsulatedObjectFrame:
[legend]
Collaboration diagram for TagLib::ID3v2::GeneralEncapsulatedObjectFrame:
[legend]

## Public Member Functions
| GeneralEncapsulatedObjectFrame ()
| GeneralEncapsulatedObjectFrame (const ByteVector &data)
virtual | ~GeneralEncapsulatedObjectFrame ()
virtual String | toString () const
String::Type | textEncoding () const
void | setTextEncoding (String::Type encoding)
String | mimeType () const
void | setMimeType (const String &type)
String | fileName () const
void | setFileName (const String &name)
String | description () const
void | setDescription (const String &desc)
ByteVector | object () const
void | setObject (const ByteVector &object)
Public Member Functions inherited from TagLib::ID3v2::Frame
virtual | ~Frame ()
ByteVector | frameID () const
unsigned int | size () const
void | setData (const ByteVector &data)
virtual void | setText (const String &text)
virtual String | toString () const =0
ByteVector | render () const
TAGLIB_DEPRECATED | Header (const ByteVector &data, bool synchSafeInts)
| Header (const ByteVector &data, unsigned int version=4)
virtual | ~Header ()
TAGLIB_DEPRECATED void | setData (const ByteVector &data, bool synchSafeInts)
void | setData (const ByteVector &data, unsigned int version=4)
ByteVector | frameID () const
void | setFrameID (const ByteVector &id)
unsigned int | frameSize () const
void | setFrameSize (unsigned int size)
unsigned int | version () const
void | setVersion (unsigned int version)
bool | tagAlterPreservation () const
void | setTagAlterPreservation (bool discard)
bool | fileAlterPreservation () const
bool | readOnly () const
bool | groupingIdentity () const
bool | compression () const
bool | encryption () const
bool | unsynchronisation () const
bool | dataLengthIndicator () const
ByteVector | render () const
TAGLIB_DEPRECATED bool | frameAlterPreservation () const

## Protected Member Functions
virtual void | parseFields (const ByteVector &data)
virtual ByteVector | renderFields () const
Protected Member Functions inherited from TagLib::ID3v2::Frame
| Frame (const ByteVector &data)
| Frame (Header *h)
Header * | header () const
void | setHeader (Header *h, bool deleteCurrent=true)
void | parse (const ByteVector &data)
virtual void | parseFields (const ByteVector &data)=0
virtual ByteVector | renderFields () const =0
ByteVector | fieldData (const ByteVector &frameData) const
String | readStringField (const ByteVector &data, String::Type encoding, int *position=0)
String::Type | checkTextEncoding (const StringList &fields, String::Type encoding) const
PropertyMap | asProperties () const

## Friends
class | FrameFactory

## Additional Inherited Members
Static Public Member Functions inherited from TagLib::ID3v2::Frame
static Frame * | createTextualFrame (const String &key, const StringList &values)
static unsigned int | headerSize ()
static unsigned int | headerSize (unsigned int version)
static ByteVector | textDelimiter (String::Type t)
static unsigned int | size ()
static unsigned int | size (unsigned int version)
Static Public Attributes inherited from TagLib::ID3v2::Frame
static const String | instrumentPrefix
static const String | commentPrefix
static const String | lyricsPrefix
static const String | urlPrefix
Static Protected Member Functions inherited from TagLib::ID3v2::Frame
static String::Type | checkEncoding (const StringList &fields, String::Type encoding)
static String::Type | checkEncoding (const StringList &fields, String::Type encoding, unsigned int version)
static ByteVector | keyToFrameID (const String &)
static String | frameIDToKey (const ByteVector &)
static String | keyToTXXX (const String &)
static String | txxxToKey (const String &)
static void | splitProperties (const PropertyMap &original, PropertyMap &singleFrameProperties, PropertyMap &tiplProperties, PropertyMap &tmclProperties)

## Detailed Description

An ID3v2 general encapsulated object frame implementation.

This is an implementation of ID3v2 general encapsulated objects. Arbitrary binary data may be included in tags, stored in GEOB frames. There may be multiple GEOB frames in a single tag. Each GEOB it labelled with a content description (which may be blank), a required mime-type, and a file name (may be blank). The content description uniquely identifies the GEOB frame in the tag.

## Constructor & Destructor Documentation

## ◆ GeneralEncapsulatedObjectFrame() [1/2]

TagLib::ID3v2::GeneralEncapsulatedObjectFrame::GeneralEncapsulatedObjectFrame | ( |  | ) |

Constructs an empty object frame. The description, file name and text encoding should be set manually.

## ◆ GeneralEncapsulatedObjectFrame() [2/2]

TagLib::ID3v2::GeneralEncapsulatedObjectFrame::GeneralEncapsulatedObjectFrame | ( | const ByteVector & | data | ) |
| explicit

Constructs a GeneralEncapsulatedObjectFrame frame based on data.

Warning
  This is not data for the encapsulated object, for that use setObject(). This constructor is used when reading the frame from the disk.

## ◆ ~GeneralEncapsulatedObjectFrame()

virtual TagLib::ID3v2::GeneralEncapsulatedObjectFrame::~GeneralEncapsulatedObjectFrame | ( |  | ) |
| virtual

Destroys the GeneralEncapsulatedObjectFrame instance.

## Member Function Documentation

## ◆ description()

String TagLib::ID3v2::GeneralEncapsulatedObjectFrame::description | ( |  | ) | const

Returns the content description of the object.

See also
  setDescription()
  textEncoding()
  setTextEncoding()

## ◆ fileName()

String TagLib::ID3v2::GeneralEncapsulatedObjectFrame::fileName | ( |  | ) | const

Returns the file name of the object.

See also
  setFileName()

## ◆ mimeType()

String TagLib::ID3v2::GeneralEncapsulatedObjectFrame::mimeType | ( |  | ) | const

Returns the mime type of the object.

## ◆ object()

ByteVector TagLib::ID3v2::GeneralEncapsulatedObjectFrame::object | ( |  | ) | const

Returns the object data as a ByteVector.

Note
  ByteVector has a data() method that returns a const char * which should make it easy to export this data to external programs.

See also
  setObject()
  mimeType()

## ◆ parseFields()

virtual void TagLib::ID3v2::GeneralEncapsulatedObjectFrame::parseFields | ( | const ByteVector & | data | ) |
| protected virtual

Called by parse() to parse the field data. It makes this information available through the public API. This must be overridden by the subclasses.

Implements TagLib::ID3v2::Frame.

## ◆ renderFields()

virtual ByteVector TagLib::ID3v2::GeneralEncapsulatedObjectFrame::renderFields | ( |  | ) | const
| protected virtual

Render the field data back to a binary format in a ByteVector. This must be overridden by subclasses.

Implements TagLib::ID3v2::Frame.

## ◆ setDescription()

void TagLib::ID3v2::GeneralEncapsulatedObjectFrame::setDescription | ( | const String & | desc | ) |

Sets the content description of the object to desc.

See also
  description()
  textEncoding()
  setTextEncoding()

## ◆ setFileName()

void TagLib::ID3v2::GeneralEncapsulatedObjectFrame::setFileName | ( | const String & | name | ) |

Sets the file name for the object.

See also
  fileName()

## ◆ setMimeType()

void TagLib::ID3v2::GeneralEncapsulatedObjectFrame::setMimeType | ( | const String & | type | ) |

Sets the mime type of the object.

## ◆ setObject()

void TagLib::ID3v2::GeneralEncapsulatedObjectFrame::setObject | ( | const ByteVector & | object | ) |

Sets the object data to data. data should be of the type specified in this frame's mime-type specification.

See also
  object()
  mimeType()
  setMimeType()

## ◆ setTextEncoding()

void TagLib::ID3v2::GeneralEncapsulatedObjectFrame::setTextEncoding | ( | String::Type | encoding | ) |

Set the text encoding used for the description and file name.

See also
  description()
  fileName()

## ◆ textEncoding()

String::Type TagLib::ID3v2::GeneralEncapsulatedObjectFrame::textEncoding | ( |  | ) | const

Returns the text encoding used for the description and file name.

See also
  setTextEncoding()
  description()
  fileName()

## ◆ toString()

virtual String TagLib::ID3v2::GeneralEncapsulatedObjectFrame::toString | ( |  | ) | const
| virtual

Returns a string containing the description, file name and mime-type

Implements TagLib::ID3v2::Frame.

## Friends And Related Function Documentation

## ◆ FrameFactory

friend class FrameFactory
| friend

The documentation for this class was generated from the following file:

- generalencapsulatedobjectframe.h